﻿var joe = new Customer { FirstName = "Joe", LastName = "Black" };
var john = new Employee{ FirstName = "John", LastName = "Doe" };
var jack = new Helper { FirstName = "Jack" };

IncreaseSalary(john);
Console.WriteLine();
IncreaseSalary(joe);

void IncreaseSalary(Person person)
{
    if (person is not (Employee or Helper))
    {
        throw new ArgumentException("Only Employee or Helper roles are supported.", nameof(person));
    }

    Console.WriteLine($"IncreaseSalary: increasing for {person} ...");
}

abstract record Person
{
    public string? FirstName { get; set; }
    public string? LastName { get; set; }
}

record Customer : Person { }
record Employee : Person { }
record Helper : Person { }
